/* getAllOpts.c - passes full range of program options to G_parser. If
                  the user uses the [-s] option indicating that he
                  is providing an input file with SQL commands the
                  function getSelectOpts is called in place of this
                  routine.

                  jaf 2/19/92
*/

#include "gis.h"
getAllOpts(argc, argv)
        int argc;
        char **argv;

{

    int retval ;
    struct Join *joinargs;
    struct Option  *tab, *coordx, *coordy, *cats,*where, *plot, *join, *map ;

	retval = 0; 

	tab = G_define_option() ;
	tab->key        = "tab" ;
	tab->type       = TYPE_STRING ;
	tab->required   = YES  ;
	tab->multiple   = NO ;
	tab->description= "Table containing X,Y coordinate values." ;


	coordx = G_define_option() ;
	coordx->key        = "coordx" ;
	coordx->type       = TYPE_STRING ;
	coordx->required   = YES  ;
	coordx->multiple   = NO ;
	coordx->key_desc   = "column of X coordinates" ;
	coordx->answer	   = "X";
	coordx->description= "Column containing X coordinate values." ;

	coordy = G_define_option() ;
	coordy->key        = "coordy" ;
	coordy->type       = TYPE_STRING ;
	coordy->required   = YES  ;
	coordy->multiple   = NO ;
	coordy->key_desc   = "column of Y coordinates" ;
	coordy->answer	   = "Y";
	coordy->description= "Column containing Y coordinate values." ;

	cats = G_define_option() ;
	cats->key        = "cats" ;
	cats->type       = TYPE_STRING ;
	cats->required   = NO  ;
	cats->multiple   = NO ;
	cats->key_desc   = "category-column" ;
	cats->answer	  = "cat";
	cats->description= "Column containing category values." ;

	where = G_define_option() ;
	where->key        = "where" ;
	where->type       = TYPE_STRING ;
	where->required   = NO  ;
	where->multiple   = NO ;
	where->description= "Where clause for query (eg. where col='paved', col=56). " ;

	map = G_define_option() ;
	map->key        = "map" ;
	map->type       = TYPE_STRING ;
	map->required   = NO  ;
	map->multiple   = NO ;
	map->description= "Name of sites list to output.";


	plot = G_define_option() ;
	plot->key        = "plot" ;
	plot->type       = TYPE_STRING ;
	plot->required   = NO  ;
	plot->multiple   = NO ;
	plot->key_desc	  ="Color,icon,size" ;
	plot->answer	  ="gray,x,3" ;
	plot->description= "Colors:red,orange,yellow,green,blue,indigo,violet,magenta,brown,gray,white,black; Icon: diamond, box, plus, x; Size: 1-9. ";


	join = G_define_option() ;
	join->key        = "join" ;
	join->type       = TYPE_STRING ;
	join->required   = NO  ;
	join->multiple   = NO ;
	join->key_desc	 = "tab,tabkey,pkey" ;
	join->description= "**Obsolete** JOIN rules (eg. table,key,primekey).\n\tHave been dropped from this interface.  Consider creating a view \n\tor running your sql from a file, if you need joins,unions,intersects,... ";


        /* Invoke parser */
        if (G_parser(argc, argv)) {
	    system("d.site.pg -s help");
            exit(-1);
	}

/*************** INFX driver code begins ***************/
        retval = buildInfxQry(tab->answer,coordx->answer,coordy->answer,
                cats->answer,where->answer,
                map->answer, join->answers, plot->answers);


	return(retval) ;
}
