

#include <stdlib.h>
#include "gis.h"
#include <stdio.h>
#include <libpq-fe.h>
#include "dbsite.h"
#define TRUE 0
#define FALSE 1

runInfxFile(SQL_stmt, map,  plotargs )
  char *SQL_stmt, *map, *plotargs[];
  {
    FILE *fp, *fpin, *fpout;
    int i,nflds;
    int retval;
    int color;
    int size;
    char *icon;
    char sysbuf[1024];
    char buf1[1024] = "";
    char buf2[1024] = "";
    char buf3[1024] = "";
    float x;
    float y;
    PGconn *pg_conn;
    PGresult *res;
    char    *pghost;
    i = 1;
    retval  = 0 ;

    color = D_translate_color(plotargs[0]);
    icon = plotargs[1];
    size = atoi(plotargs[2]);

    R_open_driver();
    D_setup() ;
    R_standard_color(color);

    if (map)	fpout=G_fopen_sites_new(map);

#ifdef VERBOSE
    printf ("\n\nExecuting\n%s;\n\n",SQL_stmt);
#endif

    if ((pghost=G_getenv("PG_HOST"))==NULL) pghost == NULL;
        
    pg_conn = PQsetdb(pghost,NULL, NULL,NULL,G_getenv("PG_DBASE"));
    if (PQstatus (pg_conn) == CONNECTION_BAD) {
      printf ("Error Selecting from Postgres:%s\n",PQcmdStatus(pg_conn));
      PQfinish(pg_conn);
      exit (-1); 
    }
  	   
    res = PQexec (pg_conn, SQL_stmt);
    if ( PQresultStatus (res) != PGRES_TUPLES_OK ) {
      printf ("Error Connecting to Postgres:%s\n",PQerrorMessage(pg_conn)); 
      PQfinish(pg_conn);
      exit (-1);      
    }
    
    nflds = PQnfields (res);
    for ( i=0; i < PQntuples(res); i++)  {
      strcpy (buf1, PQgetvalue (res, i, 0));
      strcpy (buf2, PQgetvalue (res, i, 1));
      x = atof (buf1);
      y = atof (buf2);
  /* use ascii buffer to Postgres until MSB / LSB issues can be determined */
  /* cfa 11/98    */
  
      if ( nflds == 3 ) {
      strcpy (buf3, PQgetvalue (res, i, 2));
      }
      retval = plotsite (x,y,icon,size);
      if (retval != 0) exit (-1);
      if (map) G_put_site(fpout,x,y,buf3);
    }
 	
    PQclear(res);
    /* explicitly close select result to avoid memory leaks  */ 

    PQfinish(pg_conn);
    /* close connection to database */

    if (map) fclose(fpout);

    R_close_driver();

    return(0);
}
