-- run this file on a Postgress 6.4 database to add
--   MIN and MAX aggregates for test and bpchar types;
-- Carl Anderson 11/98
-- Needed for g.stats.pg function in grass to work
-- should be binary (not plpgsql) functions for speed.

create function plpgsql_call_handler() returns opaque
         as '/usr/local/pgsql/lib/plpgsql.so'
         language 'C';
 
create trusted procedural language 'plpgsql'
        handler plpgsql_call_handler
        lancompiler 'PL/pgSQL';


create function least (text,text)
returns text as '            
<<outer>>
begin  
 IF ( $1 < $2 ) then
   return $1;
 else
   return $2;
 end if;
end;'
language 'plpgsql';

create function least (bpchar,bpchar)
returns bpchar as '            
<<outer>>
begin  
 IF ( $1 < $2 ) then
   return $1;
 else
   return $2;
 end if;
end;'
language 'plpgsql';

create function GREATEST (text,text)
returns text as '            
<<outer>>
begin  
 IF ( $1 > $2 ) then
   return $1;
 else
   return $2;
 end if;
end;'
language 'plpgsql';

create function GREATEST (bpchar,bpchar)
returns bpchar as '            
<<outer>>
begin  
 IF ( $1 > $2 ) then
   return $1;
 else
   return $2;
 end if;
end;'
language 'plpgsql'; 

create aggregate min (
   sfunc1 = LEAST,
   basetype = bpchar,
   stype1 = bpchar,
   initcond1 = ' '
   );
   
create aggregate min (
   sfunc1 = least,
   basetype = text,
   stype1 = text,
   initcond1 = ' '
   );

create aggregate max (
   sfunc1 = GREATEST,
   basetype = bpchar,
   stype1 = bpchar,
   initcond1 = ' '
   );
   
create aggregate max (
   sfunc1 = GREATEST,
   basetype = text,
   stype1 = text,
   initcond1 = ' '
   );
   
-- DO NOT run the rest of this file
-- if you do remember to 
--            drop aggregate avg text;
--            drop aggregate avg bpchar;  
-- this stuf is not working right 
   
-- create function no_func (bpchar,bpchar)
-- returns bpchar as '            
-- <<outer>>
--- begin  
--  return NULL;
-- end;'
-- language 'plpgsql'; 

-- create function no_func (text,text)
-- returns text as '            
-- <<outer>>
-- begin  NULL;
-- end;'
-- language 'plpgsql'; 
  
  
-- create aggregate avg (
--   sfunc1 = no_func,
--   basetype = bpchar,
--   stype1 = bpchar,
--   initcond1 = ''
--   );
   
-- create aggregate avg (
--   sfunc1 = no_func,
--   basetype = text,
--   stype1 = text,
--   initcond1 = ''
--   );
   
   